package link;

import java.net.*;
import java.io.*;

/**
 * implements an echo server in java.  designed for students
   behind firewalls, or suffering on an operating system that
   doesn't have inetd.
 */

public class EchoServer {

	int port = -1;
	DatagramSocket sock = null;

	public static void main(String argv[]) {
		int port = 2424;
		if(argv.length == 1) {
			Integer damn_java_with_its_many_ints = new Integer(argv[0]);
			port = damn_java_with_its_many_ints.intValue();
		}
		EchoServer esv = new EchoServer(port);
		esv.bind();
		esv.loop();
  }
	public EchoServer(int port) {
		this.port = port;
	}

	public void bind() {
		try { 
		sock = new DatagramSocket(port);		
		} catch(Exception e) {
			throw new Error("can't bind port " + port + 
				".  maybe somebody's using it?");
		}
	}
	public void loop() {


		while(true) {
			byte[] data = new byte[3000];
		  DatagramPacket dp = new DatagramPacket (data, data.length);
			try { 
				sock.receive(dp);
			} catch (IOException ioe) {
				System.out.println("IOException receiving datagram: "+ioe);
			}
			DatagramPacket replyPacket = new DatagramPacket(
				dp.getData(), 
				dp.getLength(),
				dp.getAddress(),
	      dp.getPort()
		  );
			try { 
				sock.send(replyPacket);
			} catch (IOException ioe) {
				System.out.println("IOException sending reply datagram: "+ioe);
			}
		}
	}

}
